--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-- Title            : PRAM
-- Design        : RISC_ST_CORE
-- File              : PRAM.vhd
-- Author       : Anatoli Sergyienko aser@comsys.ntu-kpi.kiev.ua
-- Version  1.0
-- Description:     	
 -- Warning    :This project is intended for teaching and scientifical purposes only,
--                  the use for another purposes is prohibited.
--                  This file can be copied, edited, but the header has to be unexchanged.
-- (C) YRIGHT A.Sergyienko
-- Modification history:
--^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
library IEEE;
use IEEE.std_logic_1164.all, IEEE.std_logic_UNSIGNED.all,work. RISC_lib.all; 
--pragma translate_off
library unisim;                --   ,   
--pragma translate_on
entity PRAM is  port( CLK : in std_logic;
      RST : in std_logic; 
      ENA:in std_logic;     --  
      ADDRI : in WORD;   --   
      INSTR : out WORD);--  
end PRAM;                      

architecture PRAM_BEH of PRAM is  --   
   signal address : natural;
begin   
   PRAM: process
      variable PROM:PMEM_ARR;
   begin
      Load_F( PROG_FILE,PROM);                     --                
      loop                    
         if   Rising_edge(CLK) and (ENA='1' or ENA='H') then
            address<= Conv_Integer(ADDRI);  -- 
         end if;            
         INSTR<=PROM(address);                    --              
         wait on CLK,RST,ADDRI,address ;
      end loop;
   end process;                
end PRAM_BEH;

